#ifndef AIEventHandler_H
#define AIEventHandler_H

// $Id: AIEventHandler.H,v 1.5 2007/05/22 13:27:19 mbrzozowski Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "EventHandler.H"
#include "Random.H"

// This class gives the event handler access to all game and gfx data

// This class handles server events
// In particular it generates game object actions

class GameStateModule;
class GfxModule;
class GameChanges;
namespace bzAI {
	class Graph;
	class AIState;
	class Coordinator;
	class AIObjectCollector; 
	class Configuration;

	enum GameType { GAME_1, GAME_2, GAME_3, GAME_4};

	class AIEventHandler : public EventHandler {

		public:
			static AIEventHandler* handler;	//there can be only one instance of AIEventHandler
			AIState* state;					//SHARED
			Coordinator* coordinator; 		//OWN
			Graph* graph;				//OWN
			Configuration* config;
			AIObjectCollector *collector;   //OWN
			GameType game_type;
			AIEventHandler(AIState*, sint4);
			~AIEventHandler();

			int current_frame;

			bool handle_event(const Event &e);

		private:

			void compute_actions();

			void updateWorld(const GameChanges*);
			Random rand; // local RNG

	};
}
#endif
