#ifndef AIGLOBAL_H_
#define AIGLOBAL_H_

#define DEBUG

#define REP(i,n) for (int i=0;i<n;++i)

#define ALL(c) (c).begin(),(c).end()


#define FORL(i,a,b) for (int i=a;i<=b;++i)


#define FOREACHFROM(begin,it,x) for (__typeof(begin) it##0=(begin); it##0!=(x).end();++it##0) \
			REP(i##0,1) for (__typeof(*(begin))& it=*it##0;i##0<1;++i##0)

#define FOREACH(it,x) FOREACHFROM((x).begin(),it,x)

#define INSTANCEOF(A,B) (dynamic_cast<B*>(A)!=NULL)

#define HANDLER (AIEventHandler::handler)


extern int DINDENT;


#define PDINDENT \
	REP(i##0, DINDENT) std :: cout << " "; 

#define PDEBUG(args...) \
	do { \
	PDINDENT \
	std :: cout << "" args << std :: endl; \
	} while (false) 

#define DENTER(args...)  \
	do { \
	PDINDENT \
	++DINDENT;\
	std :: cout << "ENTER : " << __PRETTY_FUNCTION__ << " "  args << std :: endl; \
	} while (false)
//	std :: cout << "" ##args << std :: endl;

#define DEXIT(args...) \
	do { \
	--DINDENT; \
	PDINDENT \
	std :: cout << "EXIT : "  << __PRETTY_FUNCTION__ << " "  args << std :: endl; \
	} while (false)

/*
#undef PDEBUG             	
#ifdef DEBUG
#	include <cstdio>
#   define PDEBUG(fmt, args...) fprintf(stderr, fmt , ## args)
#else
#  define PDEBUG(fmt, args...) 	
#endif
*/

#include "Global.H"
#include "TerrainBase.H"
#include "AIEventHandler.H"

typedef TerrainBase::Loc Loc;
typedef TerrainBase::Segment line_seg;
typedef std::pair<Loc, sint4> thick_point;

namespace bzAI {
	const sint4 sint4_inf = 1000000000;
	inline real8 sqr(real8 a){ return a*a;}
	inline real8 rrand(){
		return ((double)(rand()%100))/100.0;
	}
}






#endif /*AIGLOBAL_H_*/
