#ifndef Agent_H

#define Agent_H
#include "AIGlobal.H"
#include "AIObject.H"
#include "Force.H"

class GameObj;
namespace bzAI {

	class Path;
	class AIGUI;
	class Agent :public AIObject {
		friend class AIGUI;
          protected:
		Path* path;
          private:
		const static uint4 dist_close = 6;
		uint4 st_norm();
		bool path_search_delayed;
		Loc locTarget;
		AIObject *aiTarget;
		uint4 path_update_count;
		Force intentionForce;
		Force interactionForce;
		void moveTo(Loc, uint4);
		void setTarget(Loc);
		void setRotation(vec2 dir);

		
          public:
		sint4 group_id;
		std::vector<std::vector<Agent*> > groups;

		std::vector<Agent*>& getGroup();

		int rotation_dir;

		// don't move in this tick
		bool dont_move;

		Agent(GameObj*);

		bool reachedEnd();
		void addInteractionForce(Force);
		void addIntentionForce(Force);
		void gotoTarget(AIObject*);
		void gotoTarget(Loc);
		void reversePath();
                Loc getTarget();
		void stop();

		Force interactionFrom(AIObject*,real8);

		virtual void setAction() = 0;

		void setMovement();
	};


}

#endif
