
#include "Configuration.H"
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cstdlib>

using namespace std;

namespace bzAI {

Configuration::Configuration(string path){
	cout <<"Reading from "<<path<<endl;

	FILE *in=fopen(path.c_str(),"r");
	char buf[255]={0};
	while (fgets(buf,255,in)){
		if (strlen(buf)<4 || buf[0]=='#') { memset(buf,0,255); continue;}
		istringstream is(buf);
		string a,b;
		is >> a >> b;

		cout << "parameter "<<a<<" = "<<b<<endl;
		var[a]=b;
	}
}

int Configuration::getInt(string name){
	if (!var.count(name)) throw BadParamException();
	char *p=NULL;
	long int r=strtol(var[name].c_str(),	&p, 0);
	if (*p=='\0') return r; else throw BadParamException();
}

real8 Configuration::getReal8(string name){
	if (!var.count(name)) { 
		cout <<"Parameter "<< name <<" not found"<<endl; 
		throw BadParamException();
	}
	char *p=NULL;
	real8 r=strtod(var[name].c_str(),	&p);
	if (*p=='\0') 
		return r; 
	else { 
		cout << "Bad parameter real format: "<<var[name]<<endl;
		throw BadParamException();
	}
}

string Configuration::getString(string name){
	if (!var.count(name)) { 
		cout <<"Parameter "<< name <<" not found"<<endl; 
		throw BadParamException();
	}
	return var[name];
}

Configuration::Configuration(){}

Configuration Configuration::getConfig(string name){
	name.append("_");
	Configuration cfg;
	FOREACH(par,var){
		if (par.first.substr(0,name.size())==name) cfg.var[par.first.substr(name.size())]=par.second;
	}
	return cfg;
}



}
