#ifndef _CONFIG_H

#define _CONFIG_H

#include <string>
#include <map>

#include "AIGlobal.H"

namespace bzAI {


	// Read some options from a file
	//
	// First:  Configuration cfg("some.file");  // reads config from some.file
	// Next:   cfg.getInt("some_parameter");  // returns the value of some_parameter (as int) or throws exception
	// Format of the config file:
	// # comment
	// param1_name param2_value\n
	// param2_name param2_value\n
	// ...etc

	class Configuration {

		std::map<std::string,std::string> var;

		public:

		Configuration(std::string path);
		Configuration();

		int getInt(std::string name);
		real8 getReal8(std::string name);
		std::string getString(std::string name);

		Configuration getConfig(std::string prefix);
	};

	class BadParamException {

	};
}


#endif
