
#include <iostream>

#include "Fighter.H"
#include "Game.H"
#include "GameObj.H"
#include "Configuration.H"
#include "Path.H"

using namespace std;

namespace bzAI {

	Fighter::Fighter(GameObj* gob):Agent(gob),target(NULL),shooting_counter(0){
		assert(gob->component("weapon"));
	}

	bool Fighter::hasTarget(){
		if (target==NULL) return false;
		if (target->isDead) return false;
		return true;
	}
	AIObject* Fighter::getTarget(){
		return target;
	}


	void Fighter::attack(AIObject* aiob){
		target = aiob;
	//	cout << "attacking "<<aiob->getLoc()<<endl;
		gotoTarget(aiob);
	}

	bool Fighter::inRange(){
		return inRange(target);
	}
	bool Fighter::inRange(AIObject* aiob){
		return Game::distance(*gob,*aiob->gob)<getRange();
	}

		
	void Fighter::shoot(AIObject *aiob){
		dont_move=true;
		if (!path->empty()){
			stop();
			return;
		}
		cout << "shoot! target hp:" << aiob->gob->get_int("hp") <<" "<<aiob->getId() << endl;
		Vector<sint4> params;
		params.push_back(aiob->getId());
		gob->component("weapon")->set_action("attack", params);
	}
	void Fighter::setAction(){
	/*	if (inRange() && shooting_counter--==0){
			shooting_counter=HANDLER->config->getInt("fighter_shooting_delay");
			shoot(target);
			return;
		}*/
		dont_move = false;
		sint4 minhp=10000;
		AIObject *tmp_target=NULL;
		FOR_EACH_OBJ_OF(aiob, AIObject, enemy_bitmap)
			if(inRange(aiob) && aiob->gob->get_int("hp") < minhp){
				minhp=aiob->gob->get_int("hp");
				tmp_target=aiob;
			}
		if (tmp_target!=NULL) {

			shoot(tmp_target);
		}
	}

	sint4 Fighter :: getRange(){
		static sint4 range = gob->component("weapon")->get_int("max_ground_range");
		return range;
	}
}
