#include "Force.H"

using namespace bzAI;

Force::Force(real8 a, real8 b):x(a),y(b){}

Force::Force():x(0),y(0){}

Force::Force(Loc a, Loc b):x(b.x-a.x),y(b.y-a.y){}

real8 Force::norm() const {
	return sqrt(x*x+y*y);
}


Force Force::normalize(real8 l) const{
	if (norm()<0.001) return *this;
	return (*this)*(l/norm());
}

Force Force::shorten(real8 l) const{
	if (norm()>l) return normalize(l);
	return *this;
}
Force Force::rotate(real8 ang) const{
		return Force(x * cos(ang) - y * sin(ang), x * sin(ang) + y * cos(ang));
	}


Loc bzAI :: operator + (Loc l, Force f){
	return Loc(l.x + (sint4)f.x, l.y + (sint4)f.y);
}


Force bzAI :: operator + (Force f1, Force f2) {
	return Force(f1.x+f2.x,f1.y+f2.y);
}
Force bzAI :: operator - (Force f1, Force f2){
	return f1+(-f2);
}
Force bzAI :: operator - (Force f) {
	return Force(-f.x,-f.y);
}
Force bzAI :: operator * (Force f, real8 a){
	return Force(a*f.x,a*f.y);
}

Force& bzAI :: operator += (Force& f1, Force f2){
	f1=f1+f2;
	return f1;
}
Force& bzAI ::  operator -= (Force& f1, Force f2){
	f1=f1-f2;
	return f1;
}
Force& bzAI ::  operator *= (Force& f1, real8 a){
	f1=f1*a;
	return f1;
}
