#ifndef Force_H
#define Force_H

#include "Global.H"

#include "AIGlobal.H"

namespace bzAI {

	class Force {
		public:
		real8 x,y;
		Force(real8, real8);
		Force(Loc, Loc);
		Force();
		
		Force normalize(real8)const;
		Force shorten(real8)const;

		real8 norm() const;

		Force rotate(real8)const;

	};
	Force operator + (Force, Force);
	Loc operator + (Loc, Force);
	Force operator - (Force, Force);
	Force operator - (Force);
	Force operator * (Force, real8);
	Force& operator += (Force&, Force);
	Force& operator *= (Force&, real8);
	Force& operator -= (Force&, Force);


	typedef Force vec2;
}

#endif
