
#ifndef _FORMATION_H
#define _FORMATION_H

#include <vector>

#include "AIGlobal.H"
#include "Force.H"

namespace bzAI {

class Agent;



class Formation {

	protected:

	std::vector<Agent*> v;

	public:

	void addAgent(Agent*);

	uint4 size();

	virtual void createFormation(Loc, vec2)=0;
	
};

class EnemyFollowY : public Formation {

	std::vector<Agent*> enemy;

	public:

	void addEnemy(Agent*);

	void createFormation(Loc, vec2);
};


class LineFormation: public Formation {

	friend class WingsFormation;

	sint4 dist;

	public:

	enum line_rotation { ROTATE_LEFT, ROTATE_RIGHT, ROTATE_SIDES, NO_ROTATE } rot_type;
	
	LineFormation(sint4, line_rotation);
	void createFormation(Loc, vec2);

};

class WingsFormation: public Formation {

	LineFormation form_middle, form_left, form_right;

	real8 spread;
	uint4 wing_num;
	sint4 wing_dist;

	public:

	// distance between adjacent agents, number of agents on one wing, additional distance from wing to front line
	WingsFormation(sint4, uint4, sint4);

	void spreadLevel(real8);
	void wingDistance(sint4);

	void createFormation(Loc, vec2);
};

}

#endif
