#ifndef _GRAPH
#define _GRAPH

#include <iostream>

#include "Game.H"
#include "intersect.H"
#include "TerrainBase.H"
#include "AIGlobal.H"

#include <map>
#include <queue>
#include <set>
#include <list>


class GameObj;
class GameChanges;

#define MAX_VERT 10000


namespace bzAI {
        class AIObject;
	class Mineral;
	class Worker;
	class Path;
	class Obstacle;
	class Configuration;
	class AIGUI;

	inline sint4 distance2(Loc a, Loc b){return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);}
	class Graph {
			friend class AIGUI;
			GameObj* dummy;
			GameObj* getBoundary(line_seg);
			
			std::map<Loc,int> coord2v;
			std::map<int,Loc> v2coord;


			bool empty_graph;

			
			struct vert_vector {
				int t[40];
				double w[40];
				int size;
				void push_back(int,double);
				void remove(int);
				vert_vector();
			};



			vert_vector g[MAX_VERT];
                        vert_vector mirror_g[MAX_VERT];
                        int connComps[MAX_VERT];

                        void findConnectedComponents();

			Graph();

			void grid_layout(int, int, int, int);
			void visibility_layout();
			
			bool testpath(line_seg a, sint4 d, AIObject *aiob=NULL);
			
			
			int closest(Loc p);

			// ta metoda stad wyleci
			int closestFree(Loc p);

			double v_dist(int u, int v);


//			int k,l;
//			Graph(const GameChanges*, int _k, int _l, int d1, int  d2);
			
		public:

			int num_v;
			int getVertex(Loc);
                        Loc getLoc(int);

			bool inactive[MAX_VERT];
			bool mineral_input[MAX_VERT];
		

			Path* shortestPath(Loc p1, Loc p2, bool mirrored = false);
			Path* shortestPath(Loc, std::set<Loc>&, bool mirrored = false);
                        Path* nearPath(Loc, Loc, double r, bool mirrored = false);


	//		enum graph_type { GRID, VISIBILITY };

			void update(const GameChanges*);

			static Graph* generate(Configuration*);
	};
}

#endif
