
#include <list>
#include "Path.H"
#include "AIEventHandler.H"
#include "Graph.H"

using namespace std;
using namespace bzAI;

list<Loc>::iterator rev_iterator(list<Loc>& _list, list<Loc>::reverse_iterator rit){
	list<Loc>::iterator it=_list.begin();
	++rit;
	while (rit!=_list.rend()) {
		++rit; 
		++it;
	}
	return it;
}

list<Loc>::reverse_iterator rev_iterator(list<Loc>& _list, list<Loc>::iterator it){
	list<Loc>::reverse_iterator rit=_list.rbegin();
	++it;
	while (it!=_list.end()) {
		++rit; 
		++it;
	}
	return rit;
}

Path::Path(){
	l=NULL;
}
Path::Path(list<Loc>*ls, real8 h):l(ls),length(h){
  if (ls) waypoint = l->begin();
}

Path::Path(Loc a, Loc b, bool mirrored){
	Path* p = HANDLER->graph->shortestPath(a,b, mirrored);
	if (!p){
		cout << "Path not found from "<<a<<" to "<<b<<endl;
		l=NULL;
		return;
	}
	l = new list<Loc>(*p->l);
	length=p->length;
	waypoint=l->begin();
	delete p;
}

Path::~Path(){
	delete l;
}

bool Path :: empty(){
	if (!l) return true;
	return l->empty();
}
Loc Path :: beforeLast(){
	if (!l) return last_pos;
	return *(++l->rbegin());
}
Loc Path :: back(){
	if (!l) return last_pos;
	return l->back();
}
Loc Path :: getTarget(){
	if (!l) return last_pos;
	return (*waypoint);
}

void Path :: updatePos(Loc pos){
	if (!l) { last_pos=pos;return;}
	if (reachedEnd()) return;
	if (((waypoint->distance(pos) <= dist_close && *waypoint != (*(++l->rbegin()))) || (waypoint->distance(pos) <= dist_close/2)) && *waypoint!=l->back())
		++waypoint;
}

bool Path :: reachedEnd(){
	return l && waypoint == l->end();
}

void Path :: reverse(){
  l->reverse();

//  ERR("Not implemented and should not be");
}
