#ifndef PATH_H

#define PATH_H

#include <list>
#include "AIGlobal.H"


namespace bzAI {

	inline std::list<Loc>::iterator rev_iterator(std::list<Loc>&, std::list<Loc>::reverse_iterator);
	inline std::list<Loc>::reverse_iterator rev_iterator(std::list<Loc>&, std::list<Loc>::iterator);



	class Path {
		const static uint4 dist_close = 13;
		std::list<Loc> *l;
		std::list<Loc>::iterator waypoint;
		// used only if path empty
		Loc last_pos;
		real8 length;

		public:

		Path();
		Path(Loc,Loc, bool mirrored = false);
		Path(std::list<Loc>*,real8);

		~Path();

		bool empty();
		Loc back();
		Loc beforeLast();
		Loc getTarget();
		void updatePos(Loc pos);
		bool reachedEnd();

		void reverse();
	};

}

#endif
