#ifndef Worker_H
#define Worker_H

#include <iostream>
#include <stdlib.h>


#include "Global.H"
#include "GameStateModule.H"

#include "AIGlobal.H"
#include "Agent.H"


class GameObj;

namespace bzAI {
	class Mineral;
	class ControlCenter;
	class Worker : public Agent {

		public:
			const static int mineral_dist=1;
			bool isWorking;
			Mineral* mineral;
			int fetched;
			int turn;
			bool baseEncountered;
                        int inactivityTime;
			Loc last_access_loc;

			enum State {NONE, MOVE_TO, MINE, MOVE_BACK, UNLOAD, AVOID, EM_AVOID} state,previousState;
			sint4 last_speed;


			//	Worker(Graph& g,sint4 _x, sint4 _y, sint4 _tx, sint4 _ty):x(_x),y(_y),tx(_tx),ty(_ty),graph(g){}
			Worker(GameObj*);



			void setState(State s);
			void setPath(Path p);			void setPath(Loc p);

			bool hasState();

			void dropResources();

			void onDoneJob();
			void gather(Mineral*,ControlCenter*);
			bool reachedMineral();
			bool reachedControlCenter();
			void setAction();
			void mine();
			void unload();
                        void updateInactivity();
                        void updateMineral();

			ControlCenter *controlCenter;
			void setControlCenter(ControlCenter*);
	};
}
#endif /*Worker_H*/
