/** @file GameConst.C
    @see GameConst.H

    $Id: GameConst.C,v 1.5 2006/06/26 03:04:22 orts_furtak Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/libs/kernel/src/GameConst.C,v $
*/

// This is an ORTS file (c) Tim Furtak

#include "Global.H"
#include "GameConst.H"

using namespace std;


sint4 GameConst::encode_dir(sint4 dx, sint4 dy, sint4 num_headings)
{
  real8 angle = atan2(static_cast<double>(dy),static_cast<double>(dx)); // (-pi, pi]
  angle *= M_1_PI; // (-1, 1]
  angle += 1;      // (0, 2]

  sint4 dir = sint4(angle * num_headings); // [0, 2*num_headings]
  dir += 1;                                // [1, 2*num_headings+1]
  dir /= 2;                                // [0, num_headings]
  if (dir == 0) dir = num_headings;
  return dir;
}

real8 GameConst::angle_from_dir(sint4 dir, sint4 num_headings)
{
  return (-360.0 * dir) / num_headings + 180.0;
}

