// $Id: TCP_Client.C,v 1.4 2006/04/26 01:38:37 orts_mburo Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "TCP_Client.H"
#include "IO_Buffer.H"

using namespace std;

TCP_Client::~TCP_Client()
{
  close();
  if (io) { delete io; io = 0; }
}

bool TCP_Client::connect(const char *host_, sint4 port_)
{
  host = host_;
  port = port_;
  IPaddress ip;
  if (SDLNet_ResolveHost(&ip, const_cast<char*>(host_), port) != 0) return true;
  TCPsocket so = SDLNet_TCP_Open(&ip);
  if (so) {
    io = new IO_Buffer(so, clev, rnd_delay);
    assert(io);
  } else {
    ERR("can't connect");
  }
  return so == 0;
}


void TCP_Client::close()
{
  REM("closing connection");

  if (!is_closed()) {

    delete io; io = 0; 
    SDLNet_TCP_Close(so);
    so = 0;

  } else REM("!!! already closed");
}


bool TCP_Client::is_closed() const { return so == 0; }

sint4 TCP_Client::write(const string &msg) { return io->write(msg); }

sint4 TCP_Client::read(string &msg) { return io->read(msg); }

bool TCP_Client::is_good() const { return io->read_is_good() && io->write_is_good(); }
