#ifndef OGRETerrainMgr_H
#define OGRETerrainMgr_H

#include "Tile.H"
#include "GameTile.H"
#include <iostream>
#include <Ogre.h>
#include "OgreMeshManager.h"
/*===================================================================
Class OgreTerrainMgr (Singleton class).
Objective: This class is to handle all terrain functions/handling with
the rest of the program.
===================================================================*/
class OgreTerrainMgr
{
public:
	unsigned int mapWidth;
	unsigned int mapHeight;

	void drawTerrain(){  //draw all the terrain currently in Ogre.
		//for now just generate the terrain in one big blog.
		

	}

/*==================================================================
Function addTile()
Adds the specified tile to the TerrainMgr so it is rendered.
CalledFrom:: GfxModule::processChanges()
==================================================================*/
	void addTile(const GameTile &gTile){
		//Pull the corner points from the tile and how its split. |/| vs |\|
		sint4 h0, h1, h2, h3;
    		Tile::Split split;
    		gTile.get_topo(h0, h1, h2, h3, split);

		//1 given 4 points find which submesh the GameTile is in.
		//FORNOW: Just add it to a huge heap.
		//MeshPtr msh = MeshManager::getSingleton().createManual("ColourCube", "General"); // Create the mesh via the MeshManager
		//SubMesh* sub = msh->createSubMesh();  // Create one submesh
		//this->CreateNewSubMesh(gTile);
		//1.5-TODO-Generate the random vertices inbetween
	//2 add the vertices to the submesh reload the submesh.
		
		std::cout << "Tile add request" << std::endl;
	}

	static OgreTerrainMgr& getSingleton(){
		static OgreTerrainMgr _myObjM;
		return _myObjM;
	}
private:
	void CreateNewSubMesh(const GameTile &gTile){
		//Pull the corner points from the tile and how its split. |/| vs |\|
		sint4 h0, h1, h2, h3;
    		Tile::Split split;
    		gTile.get_topo(h0, h1, h2, h3, split);
    	}

	OgreTerrainMgr(){ //constrcutor private due to singleton
		mapWidth = 128;
		mapHeight = 128;
	}    
};

#endif
