#include "SWidget.H"

using namespace std;


SWidget::SWidget() {
  draw_tiles = true;
  air_map = false;
  wwidth = 0;
  wheight = 0;
  tile_points = 0;
  map = 0;
  pp = 0;

  set_name("A* panel");
}

SWidget::~SWidget() {
}

stype SWidget::event_key_down(stype key, stype /*mod*/, stype x, stype y)
{
  if (is_outside(x,y)) return stype();
  cout << "event_key_down" << endl;
  
  char index = (char)key.to_int();

  switch(index){
  
  case 't':
    draw_tiles = !draw_tiles;
    return stype(1);
  
  case 'a':
    air_map = !air_map;
    map = air_map ? env->get_air_map() : env->get_map();
    return stype(1);
 
  case 'p':
    FORS (y, map->get_h()) {
      FORS (x, map->get_w()) {
        if ((*map)(x,y).max_size >= 0) cout << " ";
        cout << (int)((*map)(x, y).max_size);
      }
      cout << endl;
    }
  case 'c':
    FORS (y, map->get_h()) {
      FORS (x, map->get_w()) {
        if ((*map)(x,y).cost >= 0 ) cout << " ";
        cout << (int)((*map)(x, y).cost);
      }
      cout << endl;
    }
    return stype(1);

  default:
    break;
  }
   
  return stype();
}

stype SWidget::draw()
{
  if (!map) return stype();
  if (!!off) return stype();

  //  cout << "draw 1" << endl;

  double xd = (double)w.to_int()/(double)wwidth;
  double yd = (double)h.to_int()/(double)wheight;  

  sint4 x = this->x.to_int();
  sint4 y = this->y.to_int();
  sint4 w = this->w.to_int();
  sint4 h = this->h.to_int();

  
  glDisable(GL_TEXTURE_2D);

  // black background
  glColor4f(0, 0, 0, 0.5);
  glBegin(GL_QUADS);

  glVertex2f(x,   y);
  glVertex2f(x+w, y);
  glVertex2f(x+w, y+h);
  glVertex2f(x,   y+h);
  
  glEnd();

  
  FORS (xi, wwidth) {
    FORS (yi, wheight) { 
      if ((*map)(xi, yi).max_size <= 0 || (*map)(xi, yi).cost != 0 ) {
	if ((*map)(xi, yi).max_size < 1) glColor4f(1, 0, 0,  1.0);
        if ((*map)(xi, yi).cost > 0)     glColor4f(0, 1, 1,  1.0);
	if ((*map)(xi, yi).cost < 0)     glColor4f(0, 0, 1,  1.0);
        glBegin(GL_QUADS);

	glVertex2f( x+xi*xd    , y+h-yi*yd   -yd );
	glVertex2f( x+xi*xd+xd , y+h-yi*yd   -yd );
	glVertex2f( x+xi*xd+xd , y+h-yi*yd+yd-yd );
	glVertex2f( x+xi*xd    , y+h-yi*yd+yd-yd ); 
    
        glEnd();      
      }
    }
  }

  if (draw_tiles) {
    glColor4f(0, 0.5, 0, 0.5);
    glBegin(GL_LINES);
    // tile grid
    double d = (double)w/(double)wwidth;
    FORT(i, wwidth){
      glVertex2d(x+i*d , y);
      glVertex2d(x+i*d , y+h);
    }
     
    d = (double)h/(double)wheight;  
    FORT(i, wheight){
      glVertex2d(x , y+i*d);
      glVertex2d(x+w , y+i*d);
    } 
    glEnd();
  }

  if (pp) {
    const Vector<UnitPath> &UnitPath = pp->get_paths();
    FORALL (UnitPath, j){
      const Vector<Point2i> &path = (*j).get_path();

      glColor4f(1, 1, 1, 1);

      glBegin(GL_LINE_STRIP);

      FORALL (path, i){
	//glVertex2f((x+((*i).x)*2*xd/tile_points)+xd/2, y+h-(((*i).y)*2*yd/tile_points)-yd/2); 
	//glVertex2f(x+(env->world2x(i->x)*xd)+xd/2, y+h-((env->world2x(i->y)*yd)+yd/2)); 
	glVertex2f((double)x+((double)env->world2x(i->x)*xd), (double)y+(double)h-(((double)env->world2x(i->y)*yd))); 
      }

      glEnd();      

      //unit
      sint4 ux = (sint4)(j->get_unit()->get_int("x"));
      sint4 uy = (sint4)(j->get_unit()->get_int("y"));
      
      glColor4f(1, 1, 1, 1);
      glBegin(GL_QUADS);

      glVertex2f(x+(env->world2x(ux))*xd,    y+h-(env->world2y(uy)*yd)-yd);
      glVertex2f(x+(env->world2x(ux))*xd+xd, y+h-(env->world2y(uy)*yd)-yd);
      glVertex2f(x+(env->world2x(ux))*xd+xd, y+h-(env->world2y(uy)*yd)   );
      glVertex2f(x+(env->world2x(ux))*xd,    y+h-(env->world2y(uy)*yd)   );
      
      glEnd();
    }
  }

  
  // red border
  glColor4f(0.5, 0, 0, 1);
  glBegin(GL_LINE_LOOP);

  glVertex2f(x  , y);
  glVertex2f(x+w, y);
  glVertex2f(x+w, y+h);
  glVertex2f(x  , y+h); 
  
  glEnd();
  
  glEnable(GL_TEXTURE_2D);
  //  cout << "draw 2" << endl;
  return stype();
}


void SWidget::set_env(Environment* env_){
  env = env_;
  map = env->get_map();
  wwidth = map->get_w();
  wheight = map->get_h(); 
}

/*
  void SWidget::draw_line(Point2i a, Point2i b)
  {
  real4 scale_x = (real4)w/(real4)world_width;
  real4 scale_y = (real4)h/(real4)world_height;

  real4 u1 = a.x;
  real4 v1 = a.y;
  real4 u2 = b.x;
  real4 v2 = b.y;

  u1 = u1*scale_x + x;
  v1 = v1*scale_y + y;
    
    
  u2 = u2*scale_x + x;
  v2 = v2*scale_y + y;
    
  v1 += h - 2*(v1-y);
  v2 += h - 2*(v2-y);
    
  glVertex2d(u1,v1);
  glVertex2d(u2,v2);
  }
*/
