//-----------------------------------------------------------------------------
/** @file searchutils.h
    Utilities for running searches.

    $Id: searchutils.h,v 1.1 2006/12/31 04:09:42 orts_furtak Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/libs/pathfinding/ua_path_lib/src/searchutils.h,v $
*/
//-----------------------------------------------------------------------------

#ifndef PATHFIND_SEARCHUTILS_H
#define PATHFIND_SEARCHUTILS_H

#include "environment.h"

//-----------------------------------------------------------------------------

namespace PathFind
{
    using namespace std;

    /** Utility operations for running searches. */
    class SearchUtils
    {
    public:
        bool checkPathExists(const Environment& env, int start, int target);

        void findRandomStartTarget(const Environment& env,
                                   int& start, int &target);

    private:
        int m_target;

        const Environment* m_env;

        vector<bool> m_mark;

        vector<vector<Environment::Successor> > m_successorStack;

        bool searchPathExists(int node, int depth);
    };
}

//-----------------------------------------------------------------------------

#endif
