
#include "PathfinderBasicImp.H"


void PathfinderBasicImp::add_obj(const Object *obj){
  TerrainBasicImp<PathfindTask>::add_obj(obj);
  pe.add_obj(obj);
}
void PathfinderBasicImp::remove_obj(const Object *obj){
  TerrainBasicImp<PathfindTask>::remove_obj(obj);
  pe.remove_obj(obj);
}
void PathfinderBasicImp::update_obj(const Object *obj){
  TerrainBasicImp<PathfindTask>::update_obj(obj);
  pe.update_obj(obj);
}
void PathfinderBasicImp::add_segments(const Vector<Segment> &segs){
  TerrainBasicImp<PathfindTask>::add_segments(segs);
  pe.add_segments(segs);
}

void PathfinderBasicImp::execute_tasks(Vector<MoveCmd> &cmds, Vector<StatusMsg> &msgs){
  //tell the path execution system to execute the tasks
  pe.execute_tasks(tasks, cmds, msgs);
  
  //Remove all tasks who have had messages sent about them
  //It has been suggested that maybe the tasks shouldn't be removed if
  //the failure is a movement failure, but for now, that's the way it is...
  FORALL (msgs, t) {
   clean_task(t->task_id);
  }
}
