/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
  $Header: /usr/bodo1/cvs/cvs/orts3/misc/orts1/CycleCounter.H,v 1.1.1.1 2004/10/11 09:09:18 orts_mburo Exp $
  $Log: CycleCounter.H,v $
  Revision 1.1.1.1  2004/10/11 09:09:18  orts_mburo
  foo

  Revision 1.1.1.1  2003/06/11 22:04:54  orts_mburo
  import


*/

#ifndef CycleCounter_H
#define CycleCounter_H

#include "Global.H"

struct CycleCounter {

public:

  union {
    uint8 c8;
    struct { uint4 l, h; } c4;
  } count_;

  void stamp() {
    __asm__ __volatile__ (".byte 0x0f,0x31" : "=a"(count_.c4.l),"=d"(count_.c4.h));
  }

  uint8 count() const { return count_.c8; }
  
  CycleCounter() { stamp(); }
};

#endif
