/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ServerClient.H"
#include "System.H"

void ServerClient::init()
{
  logged_in = false;
}

void ServerClient::close()
{
  REM("closing @" + string(host));

  if (!is_closed()) {
    System::sock_shutdown(sb.get_socket(), 2, false);
    System::sock_close(sb.get_socket(), false);
    sb.set_socket(SocketBuffer::NO_SOCKET);

  } else REM("!!! already closed");
}

bool ServerClient::is_closed()
{
  return sb.get_socket() == SocketBuffer::NO_SOCKET;
}

sint4 ServerClient::write_flush() {
  return sb.blocking_flush();
}

sint4 ServerClient::write_msg(const string &msg, bool blocking) {
  return sb.write_msg(msg, blocking);
}

sint4 ServerClient::read_msg(string &msg) {
  return sb.read_msg(msg);
}
