/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
  $Header: /usr/bodo1/cvs/cvs/orts3/misc/orts1/String.H,v 1.1.1.1 2004/10/11 09:09:18 orts_mburo Exp $
  $Log: String.H,v $
  Revision 1.1.1.1  2004/10/11 09:09:18  orts_mburo
  foo

  Revision 1.1.1.1  2003/06/11 22:04:54  orts_mburo
  import

  Revision 1.2  2001/08/17 14:57:57  mic


  changed headers

*/

#ifndef String_H
#define String_H

#include "Global.H"
#include <string>
#include <vector>

class String : public string
{
public:
  String() {}
  String( const string& s ) : string(s) {}
  String( char c ) { string t; t += c; *this = t; }
  String( ccptr s ) : string(s) {}
  String( ccptr s, sint4 n ) : string(s, n) {}
  String( ostringstream& os ) : string( os.str()) {}

  String& operator = ( ccptr s ) { string::operator = ( s ); return *this; }
  
  String& pack(); // removes leading and trailing spaces
  
  static void parse( const String& Text, String& Name, String& Rest );
  static void parse( const String& Text, vector<String>&      Names );
  static void parse( const String& Text, String& Name, String& Rest, char Sep );
  static void parse( const String& Text, vector<String>&      Names, char Sep );

  void String::form(const char* fmt, ... );

  void replace(char c1, char c2);  // c1->c2
};

#endif

