// $Id: AI_Object.H,v 1.1.1.1 2004/10/11 09:09:20 orts_mburo Exp $

// This is an ORTS file (c) Michael Chung, licensed under the GPL

#ifndef AI_Object_H
#define AI_Object_H

#include "Coord.H"

#include "AI_Common.H"

/** represents AI's information about an object */
class AI_Object {

public:
  // constructor
  AI_Object();

  sint4 id() const { return m_obj_id; }
  sint4 type() const { return m_obj_type; }
  
  bool is_friendly() const { return m_friendly; }
  sint4 hp() const { return m_hp; }
  bool has_flag() const { return m_has_flag; }
  
  bool is_visible() const { return m_visible; }
  const Point& location() const { return m_location; }
  
  bool is_unit() const { return TYPE_UNIT == m_obj_type; }
  
public:
  sint4 m_obj_id;
  sint4 m_obj_type;

  bool m_friendly;

  // unit location - on the board
  Point m_location;

  // unit statistics
  sint4 m_hp;
  bool m_has_flag;

  bool m_visible;
};

#endif
